var chalk = require('chalk');
var path = require('path');

var slug = require('slug');

var yeoman = require('yeoman-generator');
var yosay = require('yosay');

var rijksGenerator = yeoman.Base.extend({

	prompting: function() {

		this.log(yosay('Why hello there. I\'ll create a static website for your pleasure'));

    var prompts = [{
      type: 'input',
      name: 'name',
      message: 'Name',
      default: 'Plain \'ol html'
    },
    {
      type: 'input',
      name: 'description',
      message: 'Description',
      default: 'Beautiful static site'
    }];

    return this.prompt(prompts).then(function(props) {
      this.props = props;
      this.props.slug = slug(this.props.name);
    }.bind(this));
	},

	writing: function() {

    this.fs.copyTpl(
      this.templatePath('**/*'),
      this.destinationPath(this.props.slug),
      {
        name: this.props.name,
        slug: this.props.slug,
        globOptions: {dot: true}
      }
    );

	},

	install: function() {
    var dir = process.cwd() + '/' + this.props.slug;
    process.chdir(dir);

    this.installDependencies({
      bower: false,
      npm: true
    });
	},

	end: function() {
    this.log(chalk.green('All done! \'till next time'))
	}

});

module.exports = rijksGenerator;
